;***************************************************************************
;* 									   *
;* AS 1.35 - DEMOMAC.ASM                                                   *
;*									   *
;* demonstriert die Makroverarbeitungsmglichkeiiten von AS 		   *
;*									   *
;* bersetzen mit       as demomac					   *
;*									   *
;* letzte nderungen: 16. 1.1993					   *
;*									   *
;***************************************************************************

        	macexp  on		; damit man auch etwas sieht

;---------------------------------------------------------------------------
; erstmal ein einfaches einzeiliges Makro:

pushw   	macro   operand
        	move.w  operand,-(a7)
        	endm

		pushw   $4abc.w
                pushw	d0

;---------------------------------------------------------------------------
; jetzt etwas mehrzeiliges:

mylink  	macro   reg,cnt
        	move.l  reg,-(sp)
        	lea     -cnt(a7),sp
        	move.l  sp,reg
        	endm

        	mylink  a0,50

;---------------------------------------------------------------------------
; Labels in Makros bleiben lokal und erscheinen nicht in der Symbolliste:

field:		ds.w	10

FieldSet   	macro   maske
        	move    #maske,d0
        	moveq   #10,d1
        	lea     field.w,a0
schl:   	and     (a0)+,d0
        	dbra    d1,schl
        	endm

	        FieldSet $20
                FieldSet $40

;---------------------------------------------------------------------------
; Auch in Makros sind Vorwrtsrefenzen erlaubt :

forw    	macro   operand
        	tst.l   operand
        	bne.s   nozero
        	st      d0
nozero: 	nop
        	endm

		forw    d2

;---------------------------------------------------------------------------
; IRP darf auch Makroaufrufe enthalten:

        	irp     arg,d0,d2,d5
       	 	pushw   arg
        	endm

;---------------------------------------------------------------------------
; verschachtelte Makroaufrufe:

scnt    	macro   num
       	 	move.l  #num,d0
cnt:    	subq.l  #1,d0
        	tst.l   d0
        	bne.s   cnt
        	endm

bcnt    	macro   num1,num2
        	move.l  #num2,d1
cnt:    	scnt    num1
        	subq.l  #1,d0
        	tst.l   d1
        	bne.s   cnt
        	endm

        	bcnt    100,200

;---------------------------------------------------------------------------
; ergibt 20 lokale Labels:

		rept	20
                tst.l	(a0)+
                beq.s	goon
                neg.l	-4(a0)
goon:
		endm