;***************************************************************************
;* 									   *
;* AS 1.35 - DEMOPHAS.ASM                                                  *
;*									   *
;* demonstriert die Nutzung des PHASE-Befehls von AS und den Sinn von 	   *
;* ERROR-Anweisungen							   *
;*									   *
;* bersetzen mit       as demophase					   *
;*									   *
;* letzte nderungen: 16. 1.1993					   *
;*									   *
;***************************************************************************

		cpu	z80

CommonStart	equ	0fe80h		; Adresse COMMON-Bereich
CommonLen	equ	128		; Maximallnge desselben

TooLongErrorMsg equ     "Sorry, das ist zuviel..."

;MakeError       equ     1               ; Kommentarzeichen entfernen, um
					; Fehlermeldung zu provozieren

;---------------------------------------------------------------------------
; Dieser Teil ist der Verschieber, der den Interruptserver an die passende
; Stelle kopiert: Annahme, da Bereiche sich nicht berlappen!

MoveCode	ld	hl,SrcStart
		ld	de,PhaseStart
                ld	bc,PhaseEnd-PhaseStart
                ldir
                ret

;---------------------------------------------------------------------------
; hier steht die Interruptroutine (unverschoben)

SrcStart	equ	$

		phase	CommonStart
PhaseStart:     push	af
		in	a,(0)
                bit	0,a
                jr	z,NSet1
                or	10h
NSet1:		bit	1,a
		jp	z,NSet2
                or	20h
NSet2:		out	(0),a
		ei
                reti
                ifdef	MakeError
                 db	200 dup (0)
                endif
PhaseEnd:	dephase

;---------------------------------------------------------------------------
; Prfung, ob Routine zu lang:

		if	PhaseEnd-PhaseStart>CommonLen
		 error	TooLongErrorMsg
                endif

